// Function for the criterion of the problem
// Min criterion(z)

// Input :
// dim_state : number of state variables
// initial_time : value of the initial time
// initial_state : initial state vector
// final_time : value of the final time
// final_state : final state vector
// dim_optimvars : number of optimization variables
// optimvars : vector of optimization variables
// dim_constants : number of constants
// constants : vector of constants

// Output :
// criterion : expression of the criterion to minimize

#include "header_criterion"
{
	int i;
	int na = 2;     // ages 1:young, 2:old
	int nb = 14;	// illness duration
	int no = 6;		// incubation phase
  
    // "state" contains in this order : y(na), yb(na), z(na*nb), h(na*nb), D, Int_u, RunningCost pointers:
	int pz = 4;                  //  address of z in vector "state"
    int ph = pz + na * nb;   	 //  address of h in vector "state"
    int pD = ph + na * nb;		 //  address of death toll D1 and D2 in the vector "state"
	
	// constants[ppenal]=penalM, constants[ppenal + 1]=penalu, constants[ppenal + 2]=penalD, 
	int ppenal = 61;

	// CRITERION p_M M + p_u c(u) + p_d D_T
	criterion = constants[ppenal] * optimvars[0]
				+ constants[ppenal + 1] * final_state[dim_state - 1]
				+ constants[ppenal + 2] * (final_state[pD] + final_state[pD + 1]);
}
